//
// Created by trotfunky on 07/06/19.
//

#ifndef PROJECT_MAAT_UTILS_H
#define PROJECT_MAAT_UTILS_H

#include <cstdint>
#include <string>
#include <SFML/Graphics.hpp>
#include <iostream>

namespace pro_maat
{
// Used with positions on the map grid
using GridPos = std::pair<uint8_t,uint8_t>;

static constexpr uint8_t pixelsPerUnit = 50;
static constexpr char levelFolder[] = "resources/";
static constexpr char textureFolder[] = "resources/";
static constexpr char fontFolder[] = "resources/";

void errorWindow(const std::string& error);

// Good heuristic on 4-way grids
double manhattanDistance(pro_maat::GridPos leftHandSide, pro_maat::GridPos rightHandSide)
{
    // The *0.01 helps with breaking ties and minimizing exploration
    // As per http://theory.stanford.edu/~amitp/GameProgramming/Heuristics.html#breaking-ties
    return (std::abs(rightHandSide.first-leftHandSide.first)+std::abs(rightHandSide.second-leftHandSide.second))*1.01;
}

}

#endif //PROJECT_MAAT_UTILS_H
